Attribute VB_Name = "Module1"
Option Explicit

Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
 
Const MaxLen As Long = 2048

Sub Main()
   Dim Success As Boolean
   Dim Title   As String
   
   Call MsgBox("Wir lesen den Inhalt einer MessageBox aus, die ""foo"" als Titel hat" & vbCrLf & "Erstellt diese ggf. vor dem Fortschreiten", vbInformation)
   Title = ReadMessageBoxContents("foo", Success)
   
   If Success Then
      Call MsgBox("Inhalt der fremden Messagebox: """ & Title & """", vbInformation)
   Else
      Call MsgBox("Keine nichtleere Messagebox diesen Titels vorhanden!", vbExclamation)
   End If
End Sub

Public Function ReadMessageBoxContents(ByVal Title As String, Optional ByRef Success As Boolean) As String
   Dim hWndMessage   As Long
   Dim hWndSub       As Long
   Dim Buffer        As String
   
   ' Messagebox suchen
   hWndMessage = FindWindow(vbNullString, Title)
   
   ' Hmm - keine da
   If hWndMessage = 0 Then
      Success = False
      Exit Function
   Else
      ' Erstes Fenster der Klasse STATIC suchen
      hWndSub = FindWindowEx(hWndMessage, 0&, "STATIC", vbNullString)
      ' Hmm - keines da
      If hWndSub = 0 Then
         Success = False
         Exit Function
      Else
         ' Text lesen
         Buffer = ReadWindowText(hWndSub, MaxLen)
      End If
      ' Wir haben versucht, das Icon zu lesen; das ist auch in Static
      If Buffer = "" Then
         ' Neuer Versuch
         hWndSub = FindWindowEx(hWndMessage, hWndSub, "STATIC", vbNullString)
         ' Hmm - immernoch keines da
         If hWndSub = 0 Then
            Success = False
            Exit Function
         Else
            ' Text lesen - jetzt aber!
            Buffer = ReadWindowText(hWndSub, MaxLen)
         End If
      End If
   End If
   
   Success = True ' Jetzt ging's
   
   ReadMessageBoxContents = Buffer
End Function
Public Function ReadWindowText(ByVal hWnd As Long, Optional ByVal MaxLength As Long = 1024) As String
   Dim Buffer As String
   
   Buffer = String$(MaxLen, Chr$(0))
   Call GetWindowText(hWnd, Buffer, MaxLength)
   Buffer = Left$(Buffer, InStr(Buffer, Chr$(0)) - 1)
   
   ReadWindowText = Buffer
End Function

